<?php
/*
OxyScripts.com proudly presents OxyShout
Copyright (C) 2002 OxyTeam

This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version. 
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Date Started : 1/09/2002
Date Last Updated : $Id: install.php,v 1.3 2002/10/05 08:26:46 oxyscripts Exp $
Author(s) : Oxy
Description : Install script

Get the latest version of OxyShout at http://oxyshout.oxyscripts.com
*/
//
// Define some variables
//
$install_version = "1.1.5";
/* =================================== */
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE>OxyShout <?php echo $install_version; ?> Installation Process</TITLE>
<META NAME="Generator" CONTENT="OxyShout">
<style>
INPUT { 
BORDER-BOTTOM: #000000 1px solid; 
BORDER-LEFT: #000000 1px solid; 
BORDER-RIGHT: #000000 1px solid; 
BORDER-TOP: #000000 1px solid; 
font-family: Verdana, Arial, Helvetica, sans-serif; 
background: #ffffff;
FONT-SIZE: 11px 
}
.font { 
font-family: Verdana, Arial, Helvetica, sans-serif; 
font-size: 13px; 
font-style: normal; 
color: #000000; 
}
.errmsg {
font-family: Verdana, Arial, Helvetica, sans-serif; 
font-size: 13px; 
font-style: normal; 
color: red; 
}
.msg {
font-family: Verdana, Arial, Helvetica, sans-serif; 
font-size: 13px; 
font-style: normal; 
color: green; 
}
.table { 
border-bottom: 1px solid black; 
border-left: 1px solid black; 
border-right: 1px solid black; 
border-top: 1px solid black;
background: #FFFFFF;
}
.table2 { 
border-bottom: 1px solid black; 
border-left: 1px solid black; 
border-right: 1px solid black; 
border-top: 1px solid black;
background: #EFEFEF;
}
a {
color:#666666; 
text-decoration:none
} 
</style>
</HEAD>
<BODY>
<script>
<!-- Clear form function-->
function clearform(thefield){
if (thefield.defaultValue==thefield.value)
thefield.value = ""
}
</script>
<table width="70%" border="0" cellspacing="0" cellpadding="2" align="center" class="table">
  <tr>
    <td>
      <div align="center"><img src="admin/images/oxyshout.gif" width="202" height="57" alt="oxyshout"></div>
    </td>
  </tr>
  <tr>
	<td>
	<p class="font"><b>Installation Step
<?php if(empty($_GET['step'])) {  
	$step = 1; 
} else {
	$step = $_GET['step'];
	$step++;
}
echo $step; 
?> of 5</p>
	</td>
</tr>
  <tr>
    <td>
	<BR>
<?php

switch ($_GET['step']) {
//
// Case 0 : Checking
//
/* =================================== */
	case 0:
echo '<div align="left"><p class="font">The script will now check that you have uploaded everything properly, by checking that a few files in each directory are present.</p></div>';
echo '<p class="font">Checking files ...</p>';
//
// Check file exists function
//
function check_file($file) {
	$fp = @fopen($file, "r");
	if(!$fp) {
		echo "<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : You have not uploaded $file</font><BR>";
		echo "<font class=\"errmsg\"><BR>Please correct the error shown above and press refresh when done.</font><BR>";
		die;
	} else {
		echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"errmsg\"><font class=\"msg\"> $file exists.</font><BR>";
	}
	fclose($fp);
}
/* =================================== */
//
// Check the important files are here
//
/* =================================== */
check_file("mysql.php");
check_file("oxyshout_view.php");
check_file("oxyshout_help.php");
check_file("admin/index.php");
check_file("admin/includes/top.inc.php");
check_file("admin/images/oxyshout.gif");
check_file("templates/oxyshout/oxyshout_top.tpl");
check_file("templates/oxyshout/smileys/smile.gif");

echo "<BR><font class=\"msg\"><b>DONE</b></font><BR>";
/* =================================== */
//
// Check config file is CHMOD'ed properly
//
/* =================================== */
echo '<div align="left"><p class="font">The script will now check that mysql.php has the correct permissions.</p></div>';
echo '<p class="font">Checking mysql.php ...</p>';
$fp = @fopen("mysql.php", "a");
if(!$fp) {
		echo "<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : mysql.php is not writable.</font><BR>";
		echo "<font class=\"errmsg\"><BR>Please CHMOD mysql.php 777 and press refresh when done.</font><BR>";
		die;
} else {
		echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"errmsg\"><font class=\"msg\"> mysql.php is writable.</font><BR>";
}
fclose($fp);

/* =================================== */
//
// Check PHP version is at least 4.1.0
//
/* =================================== */
echo '<div align="left"><p class="font">The script will now check that your server has at least PHP 4.1.0 installed.</p></div>';

$version = phpversion();

if(empty($version)) {
	echo "<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : Could not determine the version of PHP that was running. This will not affect the running of OxyShout if you know that it at least PHP 4.1.0.</font><BR>";
}

$version = version_compare(phpversion(), "4.1.0");

if($version == -1) {
	echo "<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : PHP version is older than PHP 4.1.0</font><BR>";
	echo "<font class=\"errmsg\"><BR>Your server will not support OxyShout, as the version it is running is older than 4.1.0. Ask your server admin to upgrade by visiting <A HREF=\"http://www.php.net\">PHP.net</A></font><BR>";
	die;
}
$version = phpversion();
echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"errmsg\"><font class=\"msg\"> You are running PHP $version</font><BR>";

echo "<BR><font class=\"msg\"><b>DONE</b></font><BR>";
/* =================================== */

echo "<div align=\"center\"><p><A HREF=\"install.php?step=1\"><B>Continue..</B></A></div>";
	break;
/* =================================== */
//
// Case 1 : Request mysql information
//
/* =================================== */
	case 1:
echo '<div align="left"><p class="font">The script now needs your mySQL database information so it can connect to your database. mySQL host can be left as \'localhost\' unless you know that it is different. If you are not sure about this information, contact your host.</p></div>';
?>
<form method="post" action="install.php?step=2">
  <table width="80%" border="0" cellspacing="0" cellpadding="2" align="center" class="table2">
    <tr> 
      <td width="38%"><p class="font">mySQL Host :</td>
      <td width="62%">
        <input type="text" name="host" value="localhost">
      </td>
    </tr>
    <tr> 
      <td width="38%"><p class="font">mySQL User :</td>
      <td width="62%">
        <input type="text" name="user">
      </td>
    </tr>
    <tr> 
      <td width="38%"><p class="font">mySQL Password :</td>
      <td width="62%">
        <input type="password" name="password">
      </td>
    </tr>
    <tr> 
      <td width="38%"><p class="font">mySQL Database :</td>
      <td width="62%">
        <input type="text" name="database">
      </td>
    </tr>
	    <tr> 
      <td width="38%"><p class="font">Table prefix :</td>
      <td width="62%">
        <input type="text" name="prefix" value="oxyshout_">
      </td>
    </tr>
    <tr> 
      <td width="38%">&nbsp;</td>
      <td width="62%">
        <input type="submit" name="submit" value="Continue">
      </td>
    </tr>
  </table>
</form>
<?php
	break;
/* =================================== */
//
// Case 2 (checking mysql and writing config file)
//
/* =================================== */
	case 2:
/* =================================== */
//
// Connect
//
/* =================================== */
echo '<div align="left"><p class="font">The script is now going check that it can connect to the mySQL database using the details you supplied, and then try to write the details to the configuration file.</p></div>';
	echo '<p class="font">Connecting ...</p>';

$con = @mysql_connect("".$_POST['host']."", "".$_POST['user']."", "".$_POST['password']."") or die("<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : Could not connect to your mySQL database, go back and check your settings.</font><BR>");

@mysql_select_db("".$_POST['database']."") or die("<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : Could not connect to your mySQL database, go back and check your settings.</font><BR>");
echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Connected</font><BR>";
/* =================================== */
//
// Check if tables already exist
//
/* =================================== */	

$table_exists = mysql_query("DESCRIBE ".$_POST['prefix']."settings");
if($table_exists) {
	echo "<IMG SRC=\"admin/images/cross.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Error !\" align=\"absmiddle\"><font class=\"errmsg\"> Error : Tables with that prefix already in use, please go back and change the details.</font><BR>";
	die;
}
/* =================================== */
//
// Write config file
//
/* =================================== */	
echo '<p class="font">Writing configuration file ...</p>';
$fp = @fopen("mysql.php", "r");
$mysql_php = fread ($fp, filesize ("mysql.php"));
$config  = str_replace ("{db_host}", $_POST['host'], $mysql_php);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Writing mySQL host.</font><BR>";

$config  = str_replace ("{db_user}", $_POST['user'], $config);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Writing mySQL user.</font><BR>";

$config  = str_replace ("{db_password}", $_POST['password'], $config);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Writing mySQL password.</font><BR>";

$config  = str_replace ("{db_database}", $_POST['database'], $config);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Writing mySQL database name.</font><BR>";

$config  = str_replace ("{db_prefix}", $_POST['prefix'], $config);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Writing table prefix.</font><BR>";

$fp = fopen("mysql.php", "w");

fwrite($fp, $config);
fclose($fp);

echo "<BR><font class=\"msg\"><b>DONE</b></font><BR>";
echo "<div align=\"center\"><p class=\"font\"><A HREF=\"install.php?step=3\"><B>Continue..</B></A></p></div>";
/* =================================== */	
//
// Setup tables
//
/* =================================== */	
	break;
/* =================================== */
//
// Case 3 (setup mysql tables)
//
/* =================================== */
	case 3;
require_once("mysql.php");
echo '<div align="left"><p class="font">The script is now creating the mySQL tables that it needs to work.</p></div>';
$oxyshout = new oxyshout;
$oxyshout->connect();
echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Connected.</font><BR>";

$table_settings = "
CREATE TABLE ".$oxyshout->oxycfg['table_settings']." (
id int(11) NOT NULL auto_increment,
password text NOT NULL,
theme text NOT NULL,
contact varchar(5) NOT NULL,
post_limit int(3) NOT NULL,
site_name varchar(80) NOT NULL,
smileys int(1) NOT NULL,
bad_words int(1) NOT NULL,
name text NOT NULL,
secretname text NOT NULL,
char_limit int(4) NOT NULL,
word_wrap int(4) NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";

$query = $oxyshout->query($table_settings);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Creating settings table.</font><BR>";

$table_messages = "
CREATE TABLE ".$oxyshout->oxycfg['table_messages']." (
id int(11) NOT NULL auto_increment,
user varchar(100) NOT NULL,
contact varchar(100) NOT NULL,
message text NOT NULL,
date text NOT NULL,
ip text NOT NULL,
time text NOT NULL,
session text NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";

$query = $oxyshout->query($table_messages);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Creating messages table.</font><BR>";

$table_smileys = "
CREATE TABLE ".$oxyshout->oxycfg['table_smileys']." (
id int(11) NOT NULL auto_increment,
theme text NOT NULL,
code text NOT NULL,
image text NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";

$query = $oxyshout->query($table_smileys);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Creating smileys table.</font><BR>";

$table_words = "
CREATE TABLE ".$oxyshout->oxycfg['table_words']." (
id int(11) NOT NULL auto_increment,
word text NOT NULL,
replacement text NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";

$query = $oxyshout->query($table_words);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Creating bad words table.</font><BR>";

$table_bans = "
CREATE TABLE ".$oxyshout->oxycfg['table_bans']." (
id int(11) NOT NULL auto_increment,
ip varchar(15) NOT NULL,
reason text NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";

$query = $oxyshout->query($table_bans);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Creating ban table.</font><BR>";

echo '<div align="left"><p class="font">The script is now inserting smileys into the database.</p></div>';

$insert_smileys_wink = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':D','smilewink.gif')";
$insert_smileys_cool = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':cool:','cool.gif')";
$insert_smileys_cry = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':cry:','cry.gif')";
$insert_smileys_eek = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':eek:','eek.gif')";
$insert_smileys_bigsmile = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':biggrin:','bigsmile.gif')";
$insert_smileys_rolleyes = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':rolleyes:','rolleyes.gif')";
$insert_smileys_sad = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':(','sad.gif')";
$insert_smileys_tongue = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':p','tongue.gif')";
$insert_smileys_devil = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':devil:','devil.gif')";
$insert_smileys_mad = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':mad:','mad.gif')";
$insert_smileys_smile = "INSERT INTO ".$oxyshout->oxycfg['table_smileys']." (theme, code, image) VALUES ('oxyshout',':)','smile.gif')";

$query = $oxyshout->query($insert_smileys_wink);
$query = $oxyshout->query($insert_smileys_cool);
$query = $oxyshout->query($insert_smileys_cry);
$query = $oxyshout->query($insert_smileys_eek);
$query = $oxyshout->query($insert_smileys_bigsmile);
$query = $oxyshout->query($insert_smileys_rolleyes);
$query = $oxyshout->query($insert_smileys_sad);
$query = $oxyshout->query($insert_smileys_tongue);
$query = $oxyshout->query($insert_smileys_devil);
$query = $oxyshout->query($insert_smileys_mad);
$query = $oxyshout->query($insert_smileys_smile);

echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Smileys inserted.</font><BR>";

echo '<div align="left"><p class="font">The script is now inserting the default settings into the database.</p></div>';

$insert_settings = "INSERT INTO ".$oxyshout->oxycfg['table_settings']." VALUES (1,'a0f848942ce863cf53c0fa6cc684007d','oxyshout','url',10,'mysite.com',1,1,'myname','mysecretname','200','10')";

$query = $oxyshout->query($insert_settings);
echo "<IMG SRC=\"admin/images/check.gif\" WIDTH=\"12\" HEIGHT=\"12\" BORDER=0 ALT=\"Success !\" align=\"absmiddle\"><font class=\"msg\"> Settings inserted.</font><BR>";
echo "<BR><font class=\"msg\"><b>DONE</b></font><BR>";
echo "<div align=\"center\"><p class=\"font\"><A HREF=\"install.php?step=4\"><B>Continue..</B></A></p></div>";
/* =================================== */	
	break;

	/* =================================== */
//
// Case 4 (get setup settings)
//
/* =================================== */
	case 4;

echo '<div align="left"><p class="msg">Congratulations OxyShout is completely setup, login <A HREF="admin/index.php">here</A> using the password \'setup\' to configure your shoutbox. Don\'t forget to delete this file first though.</p></div><BR>';

	break;
}
?>
</BODY>
</HTML>