<?php
/*
OxyScripts.com proudly presents OxyShout
Copyright (C) 2002 OxyTeam

This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version. 
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Date Started : 21/08/2002
Date Last Updated : $Id: oxyshout_view.php,v 1.12 2002/10/05 08:55:24 oxyscripts Exp $
Author(s) : Oxy
Description : The shoutbox display file

Get the latest version of OxyShout at http://oxyshout.oxyscripts.com
*/
//
// Load files
//
/* =================================== */
require_once "mysql.php"; // mySQL library
$oxyshout = new oxyshout;
require_once "lang/lang.".$oxyshout->oxycfg['lang'].".php"; // Language pack
//
// Detect install script, and die if its present
//
$fp = @fopen("install.php", "r");
if(!empty($fp)) {
		echo "<div align=\"center\"><font face=\"verdana\" size=\"2\" color=\"red\">".$lang[13]."</font></div>";
		die;
}
//
// Start sessions
//
/* =================================== */
session_start();
$sessid = session_id();
/* =================================== */
//
// Start timer
//
/* =================================== */
$starttime = $oxyshout->start_timer();
/* =================================== */
//
// Load settings
//
/* =================================== */
$oxycfg["site_name"] = $oxyshout->oxycfg("site_name");
$oxycfg["contact"] = $oxyshout->oxycfg("contact");
$oxycfg["post_limit"] = $oxyshout->oxycfg("post_limit");
$oxycfg["theme"] = $oxyshout->oxycfg("theme");
$oxycfg["smileys"] = $oxyshout->oxycfg("smileys");
$oxycfg["bad_words"] = $oxyshout->oxycfg("bad_words");
$oxycfg["name"] = $oxyshout->oxycfg("name");
$oxycfg["secretname"] = $oxyshout->oxycfg("secretname");
$oxycfg["char_limit"] = $oxyshout->oxycfg("char_limit");
$oxycfg["word_wrap"] = $oxyshout->oxycfg("word_wrap");
//
// Stop undefined variable errors
//
$smileycount = 0;
$wordcount = 0;
/* =================================== */
//
// Do banned users
//
/* =================================== */
$query = $oxyshout->query("SELECT ip, reason FROM ".$oxyshout->oxycfg['table_bans']."");
while($r = mysql_fetch_array($query)) {
	$ban = ereg("^".$r["ip"]."", $_SERVER['REMOTE_ADDR']); 
	if(!empty($ban)) {
		echo $lang[1];
		echo $lang[2]."<BR>";
		echo $r["reason"];
		die;
	}
}
/* =================================== */
//
// Start page
//
/* =================================== */
$tpl['top'] = $oxyshout->do_template("top");
$tpl['top']  = str_replace ("{sitename}", $oxycfg["site_name"], $tpl['top']);
$tpl['top']  = str_replace ("{ver}", $oxyshout->oxycfg['ver'], $tpl['top']);
echo $tpl['top'];
$err = FALSE;
/* =================================== */
//
// If deletion is needed, delete it !
//
/* =================================== */
if(!empty($_GET['delete'])) {
	$res = $oxyshout->query("SELECT id FROM ".$oxyshout->oxycfg['table_messages']." WHERE time = '".$_GET['time']."' AND session = '".$sessid."' LIMIT 1");
	$owner = @mysql_fetch_array($res);

	if(empty($owner["id"])) {
		$err=true;
		$err_msg = $lang[3];
	} else {
		$err=true;
		$err_msg = $lang[4];
	}

	$result = $oxyshout->query("DELETE FROM ".$oxyshout->oxycfg['table_messages']." WHERE time = '".$_GET['time']."' AND session = '".$sessid."' LIMIT 1");
}
/* =================================== */
//
// Enter any needed details to db, if anything has been posted
//
/* =================================== */
if(!empty($_POST['submit'])) {
//
// Validate form
//
/* =================================== */
	if(!isset($_POST['name'])) {
		$err = true;
		$err_msg = $lang[5];
	}
	if(!isset($_POST['message'])) {
		$err = true;
		$err_msg = $lang[6];
	}
/* =================================== */
//
// URL Validation
//
/* =================================== */
	if(!empty($_POST['contact'])) {
		if($oxycfg["contact"] == 'url') {	
			if (substr($_POST['contact'], 0, 4) == "www."){
				$_POST['contact'] = "http://".$_POST['contact'];
			}
			$fp = @fopen($_POST['contact'], "r");
			if(empty($fp)) {
				$err = true;
				$err_msg = $lang[7];
			}
		}
/* =================================== */
//
// E-mail Validation
//
/* =================================== */
		if($oxycfg["contact"] == 'email') {
			if(!ereg("@", $_POST['contact'])) {
				$err = true;
				$err_msg = $lang[8];
			}
		}
	}
/* =================================== */
//
// Make sure user hasn't posted recently
//
/* =================================== */
	$result = $oxyshout->query("SELECT time FROM ".$oxyshout->oxycfg['table_messages']." WHERE session = '$sessid' order by id DESC LIMIT 1");
	$last_post = 0;
	while($rt = @mysql_fetch_array($result)) {
		$last_post = $rt["time"];
	}
	$time = time();
	$time = $time - 120;
	if($time < $last_post) {
		$err = true;
		$err_msg = $lang[9];
	}
/* =================================== */
//
// Make sure user isn't using admin's username
//
/* =================================== */
	if($_POST['name'] == $oxycfg["name"]) {
		$err = true;
		$err_msg = $lang[10];
	}
//
// Enforce character limit
//
if(strlen($_POST['message']) > $oxycfg["char_limit"]) {
	$err = true;
	$lang[11] = str_replace("{char_limit}", $oxycfg["char_limit"], $lang[11]);
	$err_msg = $lang[11];
}
/* =================================== */
//
// If no error message was recieved filter and insert
//
/* =================================== */
	if($err != true) {
//
// Strip unwanted tags
//
/* =================================== */
		$stripped_user = strip_tags($_POST['name'], '');
		$stripped_contact = strip_tags($_POST['contact'], '');
		$stripped_message = strip_tags($_POST['message'], '');
		//
		// mysql_escape_string
		//
		$stripped_user = mysql_escape_string($stripped_user);
		$stripped_contact = mysql_escape_string($stripped_contact);
		$stripped_message = mysql_escape_string($stripped_message);
/* =================================== */
//
// Replace secretname with name if it is present
//
		if($stripped_user == $oxycfg["secretname"]) {
			$stripped_user = $oxycfg["name"];
		}
//
// Insert the post
//
/* =================================== */
		$ip = $_SERVER['REMOTE_ADDR'];
		$time = time();
		$stripped_contact = urlencode($stripped_contact);
		$date = date("d M h:i a");
		$oxyshout->connect();
		$query = $oxyshout->query("INSERT INTO ".$oxyshout->oxycfg['table_messages']." (user, contact, message, date, ip, time, session) VALUES ('$stripped_user','$stripped_contact','$stripped_message','$date','$ip','$time','$sessid')");
		$oxyshout->close();
	}
}
$oxyshout->connect();
/* =================================== */
//
// Get posts
//
/* =================================== */
$result = $oxyshout->query("SELECT user, contact, message, date, time, ip, session FROM ".$oxyshout->oxycfg['table_messages']." ORDER BY id DESC LIMIT ".$oxycfg["post_limit"]."");
$i = 0;
while($r = @mysql_fetch_array($result)) {
/* =================================== */
//
// Alternate post templates
//
/* =================================== */
	if($i % 2) {
		$tpl['posts'] = $oxyshout->do_template("posts");
	} else {
		$tpl['posts'] = $oxyshout->do_template("alt_posts");
	}
	$i++;
	$r["contact"] = urldecode($r["contact"]);
//
// Don't make a link if a contact isn't given
//
/* =================================== */
	if(empty($r["contact"])) {
		$post  = str_replace ("{contact}", "#", $tpl['posts']);
	} else {
		$post  = str_replace ("{contact}", $r["contact"], $tpl['posts']);
	}
/* =================================== */
//
// Parse BB Code
//
/* =================================== */
	// Bold tags
	$r["message"] = str_replace ("[b]", "<b>", $r["message"]);
	$r["message"] = str_replace ("[/b]", "</b>", $r["message"]);
	// Italic tags
	$r["message"] = str_replace ("[i]", "<i>", $r["message"]);
	$r["message"] = str_replace ("[/i]", "</i>", $r["message"]);
	// Links
	$oxyshout_bb["pat"] = "#\[url=(.*?)\](.*?)\[/url\]#si";
	$oxyshout_bb["rep"] = '<a href="\1" target=\"blank\">\2</a>';
	$r["message"] = preg_replace($oxyshout_bb["pat"], $oxyshout_bb["rep"], $r["message"]);
	//
	// Wordwrap
	//
	$r["user"] = wordwrap($r["user"], $oxycfg["word_wrap"], "<br>", 1);
	$r["message"] = $oxyshout->shout_wordwrap($r["message"], $oxycfg["word_wrap"], "-");
/* =================================== */
//
// Parse Smileys
//
/* =================================== */
	if($oxycfg["smileys"] == '1') {
		$smileycount = 0;
		$smileys = $oxyshout->query("SELECT code, image FROM ".$oxyshout->oxycfg['table_smileys']." WHERE theme = '".$oxycfg["theme"]."'");
		while($s = mysql_fetch_array($smileys)) {
			$r["message"]  = str_replace ($s["code"], "<IMG SRC=\"templates/".$oxycfg["theme"]."/smileys/".$s["image"]."\" BORDER=0 ALT=\"".$s["code"]."\">", $r["message"]);
			$smileycount ++;
		}
	}
/* =================================== */
//
// Replace template tags
//
/* =================================== */
	$r["contact"] = urlencode($r["contact"]);
	$post  = str_replace ("{contact}", $r["contact"], $post);
	$post = str_replace ("{name}", $r["user"], $post);
	$post  = str_replace ("{message}", $r["message"], $post);
	$post  = str_replace ("{date}", $r["date"], $post);
/* =================================== */
//
// Let them delete a post if it is their's
//
/* =================================== */
	if($r["session"] == $sessid) {
		$post= str_replace ("{deletemsg}", "<A HREF=\"".$_SERVER['PHPSELF']."?delete=1&time=".$r["time"]."\">".$lang[12]."</A>", $post);
	} else {
		$post= str_replace ("{deletemsg}", '', $post);
	}	

/* =================================== */
//
// Filter bad words
//
	if($oxycfg["bad_words"] == '1') {
		$wordcount = 0;
		$words = $oxyshout->query("SELECT word, replacement FROM ".$oxyshout->oxycfg['table_words']."");
		while($w = mysql_fetch_array($words)) {
			$post = str_replace($w["word"], $w["replacement"], $post);
			$wordcount++;
		}
/* =================================== */
	}
//
// Strip slashes
//
	$post = stripslashes($post);
	echo $post;
}
$oxyshout->close();
/* =================================== */
//
// Get Form
//
/* =================================== */
$tpl['form'] = $oxyshout->do_template("form");
/* =================================== */
//
// Replace form tags
//
/* =================================== */
$tpl['form']  = str_replace ("{form-action}", $_SERVER['PHP_SELF'], $tpl['form']);
$tpl['form']  = str_replace ("{form-username}", "name", $tpl['form']);
$tpl['form']  = str_replace ("{form-message}", "message", $tpl['form']);
$tpl['form']  = str_replace ("{form-contact}", "contact", $tpl['form']);
$tpl['form']  = str_replace ("{form-submit}", "submit", $tpl['form']);
$tpl['form']  = str_replace ("{form-reset}", "reset", $tpl['form']);

if(!empty($_POST['name'])) {
	$tpl['form']  = str_replace ("{form-username-value}", stripslashes($_POST['name']), $tpl['form']);
} else {
	$tpl['form']  = str_replace ("{form-username-value}", "Your name", $tpl['form']);
}
if(!empty($_POST['message'])) {
	$tpl['form']  = str_replace ("{form-message-value}", stripslashes($_POST['message']), $tpl['form']);
} else {
	$tpl['form']  = str_replace ("{form-message-value}", "Your message", $tpl['form']);
}
if(!empty($_POST['contact'])) {
	$tpl['form']  = str_replace ("{form-contact-value}", stripslashes($_POST['contact']), $tpl['form']);
} else {
	$tpl['form']  = str_replace ("{form-contact-value}", "Your ".$oxycfg["contact"]."", $tpl['form']);
}
/* =================================== */
//
// Show any error messages
//
/* =================================== */
if($err == true) {
	$tpl['form']  = str_replace ("{errmsg}", $err_msg, $tpl['form']);
} else {
	$tpl['form']  = str_replace ("{errmsg}", "", $tpl['form']);
}
/* =================================== */
//
// Show form
//
/* =================================== */
echo $tpl['form'];
/* =================================== */
//
// Stop timer
//
/* =================================== */
$totaltime = $oxyshout->end_timer($starttime);
//
// System info
//
/* =================================== */
echo "\n<!-- \nOxyShout ".$oxyshout->oxycfg['ver']."\nExecuted in $totaltime \n$oxyshout->querynum queries \n".$oxyshout->filenum." template files \n$smileycount smileys \n$wordcount bad words\n -->";
/* =================================== */
//
// End page
//
/* =================================== */
$tpl['bottom'] = $oxyshout->do_template("bottom");
echo $tpl['bottom'];
/* =================================== */
?>