<?php
/*
OxyScripts.com proudly presents OxyShout
Copyright (C) 2002 OxyTeam

This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version. 
This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Date Started : 13/09/2002
Date Last Updated : $Id: oxyshout_view_all.php,v 1.7 2002/10/05 08:55:09 oxyscripts Exp $
Author(s) : Oxy
Description : View all shouts

Get the latest version of OxyShout at http://www.oxyscripts.com
*/
//
// Load files
//
/* =================================== */
require_once "mysql.php"; // mySQL library
$oxyshout = new oxyshout;
require_once "lang/lang.".$oxyshout->oxycfg['lang'].".php"; // Language pack
//
// Detect install script, and die if its present
//
$fp = @fopen("install.php", "r");
if(!empty($fp)) {
		echo "<div align=\"center\"><font face=\"verdana\" size=\"2\" color=\"red\">".$lang[13]."</font></div>";
		die;
}
/* =================================== */
//
// Start timer
//
/* =================================== */
$starttime = $oxyshout->start_timer();
/* =================================== */
//
// Load settings
//
/* =================================== */
$oxycfg["site_name"] = $oxyshout->oxycfg("site_name");
$oxycfg["contact"] = $oxyshout->oxycfg("contact");
$oxycfg["post_limit"] = $oxyshout->oxycfg("post_limit");
$oxycfg["theme"] = $oxyshout->oxycfg("theme");
$oxycfg["smileys"] = $oxyshout->oxycfg("smileys");
$oxycfg["bad_words"] = $oxyshout->oxycfg("bad_words");
$oxycfg["name"] = $oxyshout->oxycfg("name");
$oxycfg["secretname"] = $oxyshout->oxycfg("secretname");
$oxycfg["char_limit"] = $oxyshout->oxycfg("char_limit");
$oxycfg["word_wrap"] = $oxyshout->oxycfg("word_wrap");
//
// Stop undefined variable errors
//
$smileycount = 0;
$wordcount = 0;
/* =================================== */
//
// Do banned users
//
/* =================================== */
$query = $oxyshout->query("SELECT ip, reason FROM ".$oxyshout->oxycfg['table_bans']."");
while($r = mysql_fetch_array($query)) {
	$ban = ereg("^".$r["ip"]."", $_SERVER['REMOTE_ADDR']); 
	if(!empty($ban)) {
		echo $lang[1];
		echo $lang[2]."<BR>";
		echo $r["reason"];
		die;
	}
}
/* =================================== */
//
// Start page
//
/* =================================== */
$tpl['top'] = $oxyshout->do_template("top");
$tpl['top']  = str_replace ("{sitename}", $oxycfg["site_name"], $tpl['top']);
$tpl['top']  = str_replace ("{ver}", $oxyshout->oxycfg['ver'], $tpl['top']);
echo $tpl['top'];
$oxyshout->connect();
/* =================================== */
//
// Get posts
//
/* =================================== */
$result = $oxyshout->query("SELECT user, contact, message, date, time, ip, session FROM ".$oxyshout->oxycfg['table_messages']." ORDER BY id DESC");
$i = 0;
while($r = @mysql_fetch_array($result)) {
/* =================================== */
//
// Alternate post templates
//
/* =================================== */
	if($i % 2) {
		$tpl['posts'] = $oxyshout->do_template("posts");
	} else {
		$tpl['posts'] = $oxyshout->do_template("alt_posts");
	}
	$i++;
//
// Don't make a link if a contact isn't given
//
/* =================================== */
	if(empty($r["contact"])) {
		$post  = str_replace ("{contact}", "#", $tpl['posts']);
	} else {
		$post  = str_replace ("{contact}", $r["contact"], $tpl['posts']);
	}
/* =================================== */
//
// Parse BB Code
//
/* =================================== */
	// Bold tags
	$r["message"] = str_replace ("[b]", "<b>", $r["message"]);
	$r["message"] = str_replace ("[/b]", "</b>", $r["message"]);
	// Italic tags
	$r["message"] = str_replace ("[i]", "<i>", $r["message"]);
	$r["message"] = str_replace ("[/i]", "</i>", $r["message"]);
	// Links
	$oxyshout_bb["pat"] = "#\[url=(.*?)\](.*?)\[/url\]#si";
	$oxyshout_bb["rep"] = '<a href="\1" target=\"blank\">\2</a>';
	$r["message"] = preg_replace($oxyshout_bb["pat"], $oxyshout_bb["rep"], $r["message"]);
	//
	// Wordwrap
	//
	$r["user"] = wordwrap($r["user"], $oxycfg["word_wrap"], "<br>", 1);
	$r["message"] = $oxyshout->shout_wordwrap($r["message"], $oxycfg["word_wrap"], "-");
/* =================================== */
//
// Parse Smileys
//
/* =================================== */
	if($oxycfg["smileys"] == '1') {
		$smileycount = 0;
		$smileys = $oxyshout->query("SELECT code, image FROM ".$oxyshout->oxycfg['table_smileys']." WHERE theme = '".$oxycfg["theme"]."'");
		while($s = mysql_fetch_array($smileys)) {
			$r["message"]  = str_replace ($s["code"], "<IMG SRC=\"templates/".$oxycfg["theme"]."/smileys/".$s["image"]."\" BORDER=0 ALT=\"".$s["code"]."\">", $r["message"]);
			$smileycount ++;
		}
	}
/* =================================== */
//
// Replace template tags
//
/* =================================== */
	$r["contact"] = urlencode($r["contact"]);
	$post  = str_replace ("{contact}", $r["contact"], $post);
	$post = str_replace ("{name}", $r["user"], $post);
	$post  = str_replace ("{message}", $r["message"], $post);
	$post  = str_replace ("{date}", $r["date"], $post);
	$post= str_replace ("{deletemsg}", '', $post);
/* =================================== */
//
// Filter bad words
//
	if($oxycfg["bad_words"] == '1') {
		$wordcount = 0;
		$words = $oxyshout->query("SELECT word, replacement FROM ".$oxyshout->oxycfg['table_words']."");
		while($w = mysql_fetch_array($words)) {
			$post = str_replace($w["word"], $w["replacement"], $post);
			$wordcount++;
		}
/* =================================== */
	}
//
// Strip slashes
//
	$post = stripslashes($post);
	echo $post;
}
$oxyshout->close();
/* =================================== */
//
// Stop timer
//
/* =================================== */
$totaltime = $oxyshout->end_timer($starttime);
//
// System info
//
/* =================================== */
echo "\n<!-- \nOxyShout ".$oxyshout->oxycfg['ver']."\nExecuted in $totaltime \n$oxyshout->querynum queries \n".$oxyshout->filenum." template files \n$smileycount smileys \n$wordcount bad words\n -->";
/* =================================== */
//
// End page
//
/* =================================== */
$tpl['bottom'] = $oxyshout->do_template("bottom");
echo $tpl['bottom'];
/* =================================== */
?>